<?php if (!defined('APPLICATION')) exit(); ?>
<h2>Privacy Policy</h2>

<div class="Legal">
   <h3>Website Visitors</h3>
   <p>Like most website operators, Vanilla collects non-personally-identifying information of the sort that web browsers and servers typically make available, such as the browser type, language preference, referring site, and the date and time of each visitor request. Vanilla&#8217;s purpose in collecting non-personally identifying information is to better understand how Vanilla&#8217;s visitors use its website. From time to time, Vanilla may release non-personally-identifying information in the aggregate, e.g., by publishing a report on trends in the usage of its website.</p>
   <p>Vanilla also collects potentially personally-identifying information like Internet Protocol (IP) addresses. Vanilla does not use such information to identify its visitors, however, and does not disclose such information, other than under the same circumstances that it uses and discloses personally-identifying information, as described below.</p>
   
   <h3>Gathering of Personally-Identifying Information</h3>
   <p>Certain visitors to Vanilla's websites choose to interact with Vanilla in ways that require Vanilla to gather personally-identifying information. The amount and type of information that Vanilla gathers depends on the nature of the interaction. For example, we ask visitors who sign up for a forum at <a href="http://www.vanillaforums.com/">vanillaforums.com</a> to provide a username and email address. Those who engage in transactions with Vanilla are asked to provide additional information, including as necessary the personal and financial information required to process those transactions. In each case, Vanilla collects such information only insofar as is necessary or appropriate to fulfill the purpose of the visitor's interaction with Vanilla. Vanilla does not disclose personally-identifying information other than as described below. And visitors can always refuse to supply personally-identifying information, with the caveat that it may prevent them from engaging in certain website-related activities. Vanilla does not keep a copy of any credit card information once a transaction is complete.</p>
   
   <h3>Aggregated Statistics</h3>
   <p>Vanilla may collect statistics about the behavior of visitors to its websites. For instance, Vanilla may monitor the most popular forums on the VanillaForums.com site. Vanilla may display this information publicly or provide it to others. However, Vanilla does not disclose personally-identifying information other than as described below.</p>
   
   <h3>Protection of Certain Personally-Identifying Information</h3>
   <p>Vanilla discloses potentially personally-identifying and personally-identifying information only to those of its employees, contractors and affiliated organizations that (i) need to know that information in order to process it on Vanilla's behalf or to provide services available at Vanilla's websites, and (ii) that have agreed not to disclose it to others. Some of those employees, contractors and affiliated organizations may be located outside of your home country; by using Vanilla's websites, you consent to the transfer of such information to them. Vanilla will not rent or sell potentially personally-identifying and personally-identifying information to anyone. Other than to its employees, contractors and affiliated organizations, as described above, Vanilla discloses potentially personally-identifying and personally-identifying information only when required to do so by law, or when Vanilla believes in good faith that disclosure is reasonably necessary to protect the property or rights of Vanilla, third parties or the public at large. If you are a registered user of an Vanilla website and have supplied your email address, Vanilla may occasionally send you an email to tell you about new features, solicit your feedback, or just keep you up to date with what's going on with Vanilla and our products. We primarily use our various product forums to communicate this type of information, so we expect to keep this type of email to a minimum. If you send us a request (for example via a support email or via one of our feedback mechanisms), we reserve the right to publish it in order to help us clarify or respond to your request or to help us support other users. Vanilla takes all measures reasonably necessary to protect against the unauthorized access, use, alteration or destruction of potentially personally-identifying and personally-identifying information.</p>
   
   <h3>Cookies</h3>
   <p>A cookie is a string of information that a website stores on a visitor's computer, and that the visitor's browser provides to the website each time the visitor returns. Vanilla uses cookies to help Vanilla identify and track visitors, their usage of Vanilla website, and their website access preferences. Vanilla visitors who do not wish to have cookies placed on their computers should set their browsers to refuse cookies before using Vanilla's websites, with the drawback that certain features of Vanilla's websites may not function properly without the aid of cookies.</p>
   
   <h3>Ads</h3>
   <p>Ads appearing on any of our websites may be delivered to users by advertising partners, who may set cookies. These cookies allow the ad server to recognize your computer each time they send you an online advertisement to compile information about you or others who use your computer. This information allows ad networks to, among other things, deliver targeted advertisements that they believe will be of most interest to you. This Privacy Policy covers the use of cookies by Vanilla and does not cover the use of cookies by any advertisers.</p>
   
   <h3>Privacy Policy Changes</h3>
   <p>Although most changes are likely to be minor, Vanilla may change its Privacy Policy from time to time, and in Vanilla's sole discretion. Vanilla encourages visitors to frequently check this page for any changes to its Privacy Policy. If you have a vanillaforums.com account, you should also check your forum's dashboard for alerts to these changes. Your continued use of this site after any change in this Privacy Policy will constitute your acceptance of such change.</p>
</div>